module ApiService
  class BaseAction
    attr_reader :options

    def initialize(name, options)
      @options = default_options.merge(options)
      @name = name
    end

    def abort_on_fail?
      !@options[:permissive]
    end

    def fail_http_status
      @options[:fail_http_status]
    end

    private

    def default_options
      {
        permissive: false,
        fail_http_status: 422
      }
    end
  end
end
